#include <STC32G.H>
#include <INTRINS.H>
#include "Soft_Iic.h"



#if IIC_MODE == 0           //0IIC
//------------------------------------------------------------

u8 ack = 0;

//------------------------------------------------------------


void IIC_Delay2us(void)	//@22.1184MHz
{
	unsigned long edata i;

	_nop_();
	_nop_();
	_nop_();
	i = 9UL;
	while (i) i--;
}

//------------------------------------------


void IIC_Init(void)            //ӲIICʼ
{
    SCL = 1;
    SDA = 1;
}


void IIC_Start(void)            //IIC
{
    SCL = 1;
    SDA = 1;
    IIC_Delay2us();
    SDA = 0;
    IIC_Delay2us();
    SCL = 0;
    IIC_Delay2us();
}

void IIC_Stop(void)             //IIC
{
    SCL = 0;
    SDA = 0;
    IIC_Delay2us();
    SCL = 1;
    IIC_Delay2us();
    SDA = 1; 
    IIC_Delay2us();
}


void IIC_SendACK(void)          //ACK
{
    SDA = 0;
    IIC_Delay2us();
    SCL = 1;
    IIC_Delay2us();
    SCL = 0;
    IIC_Delay2us();
}

void IIC_SendNoACK(void)        //NOACK
{
    SDA = 1;
    IIC_Delay2us();
    SCL = 1;
    IIC_Delay2us();
    SCL = 0;
    IIC_Delay2us();
}


void IIC_WaitACK(void)          //ȴӻACK
{
    SDA = 1;
    IIC_Delay2us();
    SCL = 1;
    IIC_Delay2us();
    ack = SDA;
    IIC_Delay2us();
    SCL = 0;
    IIC_Delay2us();
}

void IIC_SendByte(u8 dat)       //һֽ
{
    u8 i = 8;
    do
    {
        if (dat & 0x80)
            SDA = 1;
        else
            SDA = 0;
        IIC_Delay2us();
        dat <<= 1;
        SCL = 1;
        IIC_Delay2us();
        SCL = 0;
        IIC_Delay2us();
    } while (--i);
}

u8 IIC_ReadByte(void)           //ȡһֽ
{
    u8 i = 8, dat = 0;
    SDA = 1;
    IIC_Delay2us();
    do
    {
        SCL = 1;
        IIC_Delay2us();
        dat <<= 1;
        if (SDA)
            dat |= 1;
        SCL = 0;
        IIC_Delay2us();
    } while (--i);

    return dat;
}

//---------------------ܺ---------------------

/**
 * @name IIC_Write_Byte
 * @brief IICдļֽ
 * @param slaveѡһӻĵַ
 * @param addrݵĵַ
 * @param p
 * @param numberд뼸
 * @return 
 * @version 汾v1.0
 * @date ڣ2023
 * @author ߣϫ
 * @note עͣ
 */
void IIC_Write_Byte(u8 slave,u8 addr,u8 *p,u8 number)       //IICдļֽ
{
    IIC_Start();
    IIC_SendByte(slave);
    IIC_WaitACK();
    if (!ack)
    {
        IIC_SendByte(addr);
        IIC_WaitACK();
        if (!ack)
        {
            do
            {
                IIC_SendByte(*p);
                p++;
                IIC_WaitACK();
                if (ack)
                    break;
            } while (--number);
        }
    }
    IIC_Stop();
}

/**
 * @name IIC_Read_Byte
 * @brief IICȡļֽ
 * @param slaveѡһӻĵַ
 * @param addrҪݵĵַ
 * @param p
 * @param numberд뼸
 * @return 
 * @version 汾v1.0
 * @date ڣ2023
 * @author ߣϫ
 * @note עͣͿʼ->ַд->ݵַ->Ϳʼ->ַ->
 */
void IIC_Read_Byte(u8 slave,u8 addr,u8 *p,u8 number)       //IICȡļֽ
{
    IIC_Start();
    IIC_SendByte(slave);
    IIC_WaitACK();
    if (!ack)
    {
        IIC_SendByte(addr);
        IIC_WaitACK();
        if (!ack)
        {
            IIC_Start();
            IIC_SendByte((u8)(slave + 0x01));
            IIC_WaitACK();
            if (!ack)
            {
                do
                {
                    *p = IIC_ReadByte();
                    p++;
                    if(number != 1)
                        IIC_SendACK();
                } while (--number);
                IIC_SendNoACK();
            }
            
        }
    }
    IIC_Stop();
}

/**
 * @name IIC_Read_Byte
 * @brief IICȡ16ֽ
 * @param slaveѡһӻĵַ
 * @param addrҪݵĵַ
 * @param p
 * @param numberд뼸
 * @return 
 * @version 汾v1.0
 * @date ڣ2023
 * @author ߣϫ
 * @note עͣͿʼ->ַд->ݵַ->Ϳʼ->ַ->
 */
void IIC_Read_16Byte(u8 slave,u16 addr,u8 *p,u8 number)       //IICȡļֽ
{
    IIC_Start();
    IIC_SendByte(slave);
    IIC_WaitACK();
    if (!ack)
    {
        IIC_SendByte((u8)(addr>>8));
        IIC_WaitACK();
		IIC_SendByte((u8)addr);
        IIC_WaitACK();
        if (!ack)
        {
            IIC_Start();
            IIC_SendByte((u8)(slave + 0x01));
            IIC_WaitACK();
            if (!ack)
            {
                do
                {
                    *p = IIC_ReadByte();
                    p++;
                    if(number != 1)
                        IIC_SendACK();
                } while (--number);
                IIC_SendNoACK();
            }
            
        }
    }
    IIC_Stop();
}

#elif IIC_MODE == 1             //1ӲIIC

//------------------------------------------------------------





//------------------------------------------------------------


void IIC_Delay2us(void)	//@22.1184MHz
{
	while( !(I2CMSST & 0X40) );
    I2CMSST &= ~(0x40);
}

//------------------------------------------


void IIC_Init(void)            //ӲIICʼ
{
    I2C_S1 = 0;                 //IIC
    I2C_S0 = 1;
    I2CCFG = 0XE0;              //ٶȺʹIIC
    I2CMSST = 0;                //״̬
}


void IIC_Start(void)            //IIC
{
    I2CMSCR = 0X01;             //ʼ
    IIC_Delay2us();             //ȴ
}

void IIC_Stop(void)             //IIC
{
    I2CMSCR = 0X06;             //
    IIC_Delay2us();             //ȴ
}


void IIC_SendACK(void)          //ACK
{
    I2CMSST = 0X00;             //׼ACK
    I2CMSCR = 0X05;             //ACK
    IIC_Delay2us();
}

void IIC_SendNoACK(void)        //NOACK
{
    I2CMSST = 0X01;             //׼NOACK
    I2CMSCR = 0X05;             //NOACK
    IIC_Delay2us();
}


void IIC_WaitACK(void)          //ȴӻACK
{
    I2CMSCR = 0X03;             //ACK
    IIC_Delay2us();
}

void IIC_SendByte(u8 dat)       //һֽ
{
    I2CTXD = dat;               //͵дĴ
    I2CMSCR = 0X02;             //ָ
    IIC_Delay2us();
}

u8 IIC_ReadByte(void)           //ȡһֽ
{
    I2CMSCR = 0X04;             //ָ
    IIC_Delay2us();

    return I2CRXD;
}

//---------------------ܺ---------------------

/**
 * @name IIC_Write_Byte
 * @brief IICдļֽ
 * @param slaveѡһӻĵַ
 * @param addrݵĵַ
 * @param p
 * @param numberд뼸
 * @return 
 * @version 汾v1.0
 * @date ڣ2023
 * @author ߣϫ
 * @note עͣ
 */
void IIC_Write_Byte(u8 slave,u8 addr,u8 *p,u8 number)       //IICдļֽ
{
    IIC_Start();
    IIC_SendByte(slave);
    IIC_WaitACK();
    
    IIC_SendByte(addr);
    IIC_WaitACK();

    do
    {
        IIC_SendByte(*p);
        p++;
        IIC_WaitACK();
    } while (--number);
    
    IIC_Stop();
}

/**
 * @name IIC_Read_Byte
 * @brief IICȡļֽ
 * @param slaveѡһӻĵַ
 * @param addrҪݵĵַ
 * @param p
 * @param numberд뼸
 * @return 
 * @version 汾v1.0
 * @date ڣ2023
 * @author ߣϫ
 * @note עͣͿʼ->ַд->ݵַ->Ϳʼ->ַ->
 */
void IIC_Read_Byte(u8 slave,u8 addr,u8 *p,u8 number)       //IICȡļֽ
{
    IIC_Start();
    IIC_SendByte(slave);
    IIC_WaitACK();

    IIC_SendByte(addr);
    IIC_WaitACK();

    IIC_Start();
    IIC_SendByte((u8)(slave + 0x01));
    IIC_WaitACK();

    do
    {
        *p = IIC_ReadByte();
        p++;
        if(number != 1)
            IIC_SendACK();
    } while (--number);
    IIC_SendNoACK();
    IIC_Stop();
}

#endif

