#include <STC32G.H>
#include "UART.h"

u8 TX2_Cnt;    //ͼ
u8 RX2_Cnt;    //ռ
bit B_TX2_Busy; //æ־

u8 RX2_Buffer[UART2_BUF_LENGTH]; //ջ
u8 state1;						//logic
bit Rec_Flag1 = 0;           //ɱ־λ

u8  TX3_Cnt;    //ͼ
u8  RX3_Cnt;    //ռ
bit B_TX3_Busy; //æ־

u8  RX3_Buffer[UART3_BUF_LENGTH]; //ջ
u8 state2;						//logic
bit Rec_Flag2 = 0;           //ɱ־λ

//========================================================================
// : void UART2_config(u8 brt)
// : UART2ʼ
// : brt: ѡ, 2: ʹTimer2, ֵ: Ч.
// : none.
// 汾: VER1.0
// : 2014-11-28
// ע: 
//========================================================================
void UART2_config(u8 brt)    // ѡ, 2: ʹTimer2, ֵ: Ч.
{
    if(brt == 2)
    {
        SetTimer2Baudraye(Baudrate2);

        S2CFG |= 0x01;     //ʹô2ʱW1λΪ1ܻԤڵĴ
        S2CON = (S2CON & 0x3f) | 0x40;    //UART2ģʽ, 0x00: ͬλ, 0x40: 8λ,ɱ䲨, 0x80: 9λ,̶, 0xc0: 9λ,ɱ䲨
        ES2   = 1;         //ж
        S2REN = 1;         //
        S2_S  = 1;         //UART2 switch to: 0: P1.0 P1.1,  1: P4.6 P4.7

        B_TX2_Busy = 0;
        TX2_Cnt = 0;
        RX2_Cnt = 0;
    }
}

void UART3_config(u8 brt)    // ѡ, 2: ʹTimer2, ֵ: ʹTimer3.
{
    if(brt == 2)
    {
        SetTimer2Baudraye(Baudrate3);
        S3CON = 0x10;       //8λ, ʹTimer2ʷ, 
    }
    else
    {
        T3R = 0;		//Timer stop
        S3CON = 0x50;       //8λ, ʹTimer3ʷ, 
        T3H = (u8)(Baudrate3 / 256);
        T3L = (u8)(Baudrate3 % 256);
        T3_CT = 0;	//Timer3 set As Timer
        T3x12 = 1;	//Timer3 set as 1T mode
        T3R = 1;		//Timer run enable
    }
    ES3  = 1;       //UART3ж
    S3_S = 1;       //UART3 switch bit1 to: 0: P0.0 P0.1,  1: P5.0 P5.1

    B_TX3_Busy = 0;
    TX3_Cnt = 0;
    RX3_Cnt = 0;
}

//========================================================================
// : SetTimer2Baudraye(u32 dat)
// : Timer2ʷ
// : dat: Timer2װֵ.
// : none.
// 汾: VER1.0
// : 2014-11-28
// ע: 
//========================================================================
void SetTimer2Baudraye(u32 dat)
{
    T2R = 0;		//Timer stop
    T2_CT = 0;	//Timer2 set As Timer
    T2x12 = 1;	//Timer2 set as 1T mode
    T2H = (u8)(dat / 256);
    T2L = (u8)(dat % 256);
    ET2 = 0;    //ֹж
    T2R = 1;		//Timer run enable
}


//========================================================================
// : void PrintString2(u8 *puts)
// : 2ַ
// : puts:  ַָ.
// : none.
// 汾: VER1.0
// : 2014-11-28
// ע: 
//========================================================================
void PrintString2(u8 *puts)
{
    for (; *puts != 0;  puts++)     //ֹͣ0
    {
        S2BUF = *puts;
        B_TX2_Busy = 1;
        while(B_TX2_Busy);
    }
}


void PrintString3(u8 *puts)
{
    for (; *puts != 0;  puts++)     //ֹͣ0
    {
        S3BUF = *puts;
        B_TX3_Busy = 1;
        while(B_TX3_Busy);
    }
}

//========================================================================
// : void UART2_int (void) interrupt UART2_VECTOR
// : UART2жϺ
// : nine.
// : none.
// 汾: VER1.0
// : 2014-11-28
// ע: 
//========================================================================
void UART2_int (void) interrupt 8
{
	
    if(S2RI)            //յ
    {
        S2RI = 0;    //Clear Rx flag
        RX2_Buffer[RX2_Cnt] = S2BUF;
		if(++RX2_Cnt >= UART2_BUF_LENGTH)	RX2_Cnt = 0;
		Rec_Flag1 = 1;
		state1 = RX2_Buffer[RX2_Cnt == 0 ? 127 : (RX2_Cnt - 1)];
    }

    if(S2TI)
    {
        S2TI = 0;    //Clear Tx flag
        B_TX2_Busy = 0;
    }
}

void UART3_int (void) interrupt 17
{
    if(S3RI)            //յ
    {
        S3RI = 0;    //Clear Rx flag
        RX3_Buffer[RX3_Cnt] = S3BUF;

		if(++RX3_Cnt >= UART3_BUF_LENGTH)	RX3_Cnt = 0;
		Rec_Flag2 = 1;
		state2 = RX3_Buffer[RX3_Cnt == 0 ? 127 : (RX3_Cnt - 1)];
    }

    if(S3TI)
    {
        S3TI = 0;    //Clear Tx flag
        B_TX3_Busy = 0;
    }
}



//ض
void UartPutc(u8 dat)   
{
    S2BUF = dat;
    B_TX2_Busy = 1;
    while(B_TX2_Busy);
}

char putchar(char c)
{
    UartPutc(c);
    return c;
}
