#include <STC32G.H>

#include "oled.h"
#include "Soft_Iic.h"
#include "oled_font.h"

#include <INTRINS.H>
#include <stdlib.h>

//------------------------------------------------------------




//------------------------------------------------------------

//OLEDԴ
//Ÿʽ.
//[0]0 1 2 3 ... 127
//[1]0 1 2 3 ... 127
//[2]0 1 2 3 ... 127
//[3]0 1 2 3 ... 127
//[4]0 1 2 3 ... 127
//[5]0 1 2 3 ... 127
//[6]0 1 2 3 ... 127
//[7]0 1 2 3 ... 127

#if OLED_BUFFER_MODE

uint8_t OLED_GRAM[Max_Row / 8][Max_Column] = {0};

#endif

/**************************************************************************
Function: Refresh the OLED screen
Input   : none
Output  : none
ܣˢOLEDĻ
ڲ
  ֵ
**************************************************************************/
void OLED_Refresh_Gram(void)
{
#if OLED_BUFFER_MODE
    uint16_t i;
    OLED_Set_Pos(0, 128);
    for (i = 0; i < Max_Row / 8 * Max_Column; i++)
    {
        OLED_Write_Byte(OLED_GRAM[0][i], OLED_DATA);
    }
#endif
}



/**
 * @name OLED_Write_Byte
 * @brief SSD1306дһֽ
 * @param dat:Ҫд/
 * @param cmd:/ݱ־ 0ʾ 1ʾ
 * @return 
 * @version 汾v1.0
 * @date ڣ2023-12-30
 * @author ߣϫ
 * @note עͣ
 */
void OLED_Write_Byte(u8 dat,u8 cmd)
{
    if (cmd)
        IIC_Write_Byte(SLAVE_OLED_096, OLED_WriteData_Addr, &dat, 1);
    else
        IIC_Write_Byte(SLAVE_OLED_096, OLED_WriteCom_Addr, &dat, 1);
}

/**
 * @name OLED_Set_Pos
 * @brief úĻʾ꣨λã
 * @param xy: ʾ
 * @return 
 * @version 汾v1.0
 * @date ڣ2023-12-30
 * @author ߣϫ
 * @note עͣ
 */
void OLED_Set_Pos(u8 x,u8 y)
{
    OLED_Write_Byte((u8)(0XB0 + y), OLED_CMD);
    OLED_Write_Byte(((x & 0xf0) >> 4) | 0x10, OLED_CMD);
    OLED_Write_Byte((x & 0x0f), OLED_CMD);
}


/**
 * @name OLED_Display_On
 * @brief OLEDʾ
 * @param 
 * @return 
 * @version 汾v1.0
 * @date ڣ2023-12-30
 * @author ߣϫ
 * @note עͣ
 */
void OLED_Display_On(void)
{
    OLED_Write_Byte(0x8d, OLED_CMD);    // DCDC
    OLED_Write_Byte(0x14, OLED_CMD);    //DCDC ON
    OLED_Write_Byte(0xaf, OLED_CMD);    //ʾ
}

/**
 * @name OLED_Display_Off
 * @brief رOLEDʾ
 * @param 
 * @return 
 * @version 汾v1.0
 * @date ڣ2023-12-30
 * @author ߣϫ
 * @note עͣ
 */
void OLED_Display_Off(void)
{
    OLED_Write_Byte(0x8d, OLED_CMD);    // DCDC
    OLED_Write_Byte(0x10, OLED_CMD);    //DCDC OFF
    OLED_Write_Byte(0xae, OLED_CMD);    //ʾر
}

/**
 * @name OLED_Clear
 * @brief 
 * @param 
 * @return 
 * @version 汾v1.0
 * @date ڣ2023-12-30
 * @author ߣϫ
 * @note עͣ,ĻǺɫĺûһ
 */
void OLED_Clear(void)
{
#if OLED_BUFFER_MODE
    u8 i;
    for (i = 0; i < Max_Row / 8 * Max_Column; i++)
    {
        OLED_GRAM[0][i] = 0;
    }
    OLED_Refresh_Gram(); //Update the display //ʾ
#else
    u8 i, n;
    for (i = 0; i<8; i++)
    {
        OLED_Write_Byte((u8)(0xb0 + i), OLED_CMD);    //ҳַ0~7
        OLED_Write_Byte(0x00, OLED_CMD);        //ʾλáе͵ַ
        OLED_Write_Byte(0x10, OLED_CMD);        //ʾλáиߵַ
        for (n = 0; n < Max_Column; n++)
            OLED_Write_Byte(0, OLED_DATA);
    }//ʾ
#endif
}

/**
 * @name OLED_ShowChar
 * @brief ָλʾһַ,ַ
 * @param x:0~127
 * @param y:0~63
 * @param chr:
 * @param charSize:ѡ16/6
 * @param Is_Reverse:0ʾ 1ʾ
 * @return 
 * @version 汾v1.0
 * @date ڣ2023-12-30
 * @author ߣϫ
 * @note עͣ
 */
void OLED_ShowChar(u8 x, u8 y, u8 chr, u8 charSize, u8 Is_Reverse)
{
    u8 i = 0;
    chr -= ' ';	//õƫƺֵ
    if (x > Max_Column - 1)
    {
        x = 0;
        y = y + 2;
    }
#if OLED_BUFFER_MODE
    if(charSize == 16)
    {
		for(i = 0; i < 8; i++)
		{
			OLED_GRAM[y][x+i] = Is_Reverse == 0?F8X16[chr][i]:~F8X16[chr][i];
			OLED_GRAM[y+1][x+i] = Is_Reverse == 0?F8X16[chr][i+8]:~F8X16[chr][i+8];
		}
    }
    else if(charSize == 6)
    {
		for(i=0; i<6; i++)
		{
			OLED_GRAM[y][x+i] = Is_Reverse == 0?F8X6[chr][i]:~F8X6[chr][i];
		}
    }
#else
    if (charSize == 16)
    {
        OLED_Set_Pos(x, y);
        for (i = 0; i<8; i++)
            OLED_Write_Byte(Is_Reverse == 0?F8X16[chr][i]:~F8X16[chr][i], OLED_DATA);
        OLED_Set_Pos(x, (u8)(y + 1));
        for (i = 0; i<8; i++)
            OLED_Write_Byte(Is_Reverse == 0?F8X16[chr][i + 8]:~F8X16[chr][i + 8], OLED_DATA);
    }
    else if(charSize == 6)
    {
        OLED_Set_Pos(x, y);
        for (i = 0; i<6; i++)
            OLED_Write_Byte(Is_Reverse == 0?F8X6[chr][i]:~F8X6[chr][i], OLED_DATA);
    }
#endif
}

/**
 * @name OLED_Index
 * @brief m^n
 * @param m^n
 * @return result
 * @version 汾v1.0
 * @date ڣ2023-12-30
 * @author ߣϫ
 * @note עͣ
 */
u32 OLED_Index(u8 m, u8 n)
{
    u32 result = 1;
    while (n--)result *= m;
    return result;
}


/**
 * @name OLED_ShowNum
 * @brief ʾ2
 * @param xy
 * @param numֵ(0~4294967295)
 * @param lenֵλʾλЧ
 * @param SizeС16/6
 * @param Is_Reverseģʽ 0ڵװ 1׵׺
 * @return 
 * @version 汾v1.0
 * @date ڣ2023-12-30
 * @author ߣϫ
 * @note עͣ
 */
void OLED_ShowNum(u8 x, u8 y, u32 num, u8 len, u8 Size, u8 Is_Reverse)
{
    u8 t, temp;
    u8 enshow = 0;
    for (t = 0; t < len; t++)
    {
        temp = (num / OLED_Index(10, (u8)(len - t - 1))) % 10;
        if (enshow == 0 && t < (len - 1))
        {
            if (temp == 0)
            {
                OLED_ShowChar((u8)(x + 8 * t), y, ' ', Size, Is_Reverse);
                continue;
            }
            else
                enshow = 1;

        }
        OLED_ShowChar((u8)(x + 8 * t), y, (u8)(temp + '0'), Size, Is_Reverse);
    }
}

/**
 * @name OLED_ShowString
 * @brief ʾһַŴ
 * @param xy
 * @param chrҪʾַ
 * @param charSizeС16/6
 * @param Is_Reverseģʽ 0ڵװ 1׵׺
 * @return 
 * @version 汾v1.0
 * @date ڣ2023-12-30
 * @author ߣϫ
 * @note עͣ
 */
void OLED_ShowString(u8 x, u8 y, char *chr, u8 charSize, u8 Is_Reverse)
{
    u8 j = 0;
    while (chr[j] != '\0')
    {
        OLED_ShowChar(x, y, chr[j], charSize, Is_Reverse);
        x += 8;
        if (x>120)
        {
            x = 0;
            y += 2;
        }
        j++;
    }
}

/**
 * @name OLED_ShowChinese
 * @brief ʾ
 * @param xy
 * @param noҪʾַ
 * @param Is_Reverseģʽ 0ڵװ 1׵׺
 * @return 
 * @version 汾v1.0
 * @date ڣ2023-12-31
 * @author ߣϫ
 * @note עͣ
 */
void OLED_ShowChinese(u8 x, u8 y, u8 no, u8 Is_Reverse)
{
    u8 i;
#if OLED_BUFFER_MODE
    for (i = 0; i < 16; i++)
    {
		OLED_GRAM[y][x+i] = Is_Reverse == 0?Hzk[2 * no][i]:~Hzk[2 * no][i];
		OLED_GRAM[y+1][x+i] = Is_Reverse == 0?Hzk[2 * no + 1][i]:~Hzk[2 * no + 1][i];
    }
#else
    OLED_Set_Pos(x, y);
    for (i = 0; i < 16; i++)
    {
        OLED_Write_Byte(Is_Reverse == 0?Hzk[2 * no][i]:~Hzk[2 * no][i], OLED_DATA);
    }
    OLED_Set_Pos(x, (u8)(y + 1));
    for (i = 0; i<16; i++)
    {
        OLED_Write_Byte(Is_Reverse == 0?Hzk[2 * no + 1][i]:~Hzk[2 * no + 1][i], OLED_DATA);
    }
#endif
}


/**
 * @name OLED_DrawBMP
 * @brief ʾʾBMPͼƬ
 * @param x0y0ʼ(x,y),xķΧ0127yΪҳķΧ07
 * @param x1y1
 * @param BMP[]ҪʾBMP
 * @param Is_Reverseģʽ 0ڵװ 1׵׺
 * @return 
 * @version 汾v1.0
 * @date ڣ2023-12-31
 * @author ߣϫ
 * @note עͣʾBMPͼƬ12864
 */
void OLED_DrawBMP(u8 x0, u8 y0, u8 x1, u8 y1, u8 BMP[], u8 Is_Reverse)
{
    u16 j = 0;
    u8 x, y;

    if (y1 % 8 == 0) 
		y = y1 / 8;
    else 
		y = y1 / 8 + 1;
#if OLED_BUFFER_MODE
    for (y = y0; y<y1; y++)
    {
        for (x = x0; x<x1; x++)
        {
			OLED_GRAM[y][x] = Is_Reverse == 0?BMP[j++]:~BMP[j++];
        }
    }
#else
    for (y = y0; y<y1; y++)
    {
        OLED_Set_Pos(x0, y);
        for (x = x0; x<x1; x++)
        {
            OLED_Write_Byte(Is_Reverse == 0?BMP[j++]:~BMP[j++], OLED_DATA);
        }
    }
#endif
}

/**
 * @name OLED_Init
 * @brief ʼSSD1306
 * @param 
 * @return 
 * @version 汾v1.0
 * @date ڣ2023-12-31
 * @author ߣϫ
 * @note עͣ
 */
void OLED_Init(void)
{
    OLED_Write_Byte(0xAE, OLED_CMD);//--turn off oled panel ʾ

    OLED_Write_Byte(0x00, OLED_CMD);//---set low column address	õеַ
    OLED_Write_Byte(0x10, OLED_CMD);//---set high column address øеַ

    OLED_Write_Byte(0x40, OLED_CMD);//--set start line address  Set Mapping RAM Display Start Line (0x40~0x7F) ʾʼ

    OLED_Write_Byte(0xDA, OLED_CMD);//--set com pins hardware configuration  COM Ӳ
    OLED_Write_Byte(0x12, OLED_CMD);

#if OLED_BUFFER_MODE
    OLED_Write_Byte(0x20, OLED_CMD);//-Set Page Addressing Mode (0x00/0x01/0x02) ڴַģʽ
    OLED_Write_Byte(0x00, OLED_CMD);//

    OLED_Write_Byte(0xD3, OLED_CMD);//-set display offset	Shift Mapping RAM Counter (0x00~0x3F)	ʾƫ
    OLED_Write_Byte(0x00/*8ı*/,OLED_CMD);
#else
    OLED_Write_Byte(0x20, OLED_CMD);//-Set Page Addressing Mode (0x00/0x01/0x02) ڴַģʽ
    OLED_Write_Byte(0x02, OLED_CMD);//

    OLED_Write_Byte(0xD3, OLED_CMD);//-set display offset	Shift Mapping RAM Counter (0x00~0x3F)	ʾƫ
    OLED_Write_Byte(0x00/*8ı*/, OLED_CMD);//-not offset
#endif
    OLED_Write_Byte(0xA1, OLED_CMD);//--Set SEG/Column Mapping     0xa0ҷ 0xa1
    OLED_Write_Byte(0xC8, OLED_CMD);//Set COM/Row Scan Direction   0xc0· 0xc8

    OLED_Write_Byte(0xDB, OLED_CMD);//--set vcomh	 Vcomh ȡѡˮƽ
    OLED_Write_Byte(0x30, OLED_CMD);//Set VCOM Deselect Level

    OLED_Write_Byte(0xD8,OLED_CMD);//set area color mode off
    OLED_Write_Byte(0x05,OLED_CMD);//

    OLED_Write_Byte(0x81, OLED_CMD);//--set contrast control register Ϊ BANK0 öԱȶȿ
    OLED_Write_Byte(Brightness, OLED_CMD); //1~ 255; Default 0x7f (brightness Settings, the bigger the brighter) //1~255;Ĭ0X7F (,ԽԽ)

    OLED_Write_Byte(0xA8, OLED_CMD);//--set multiplex ratio(1 to 64)	ø
    OLED_Write_Byte(0x3f, OLED_CMD);//--1/64 duty

    OLED_Write_Byte(0xd5, OLED_CMD);//--set display clock divide ratio/oscillator frequency	ʾʱӷƵʡƵ
    OLED_Write_Byte(0x80, OLED_CMD);//--set divide ratio, Set Clock as 100 Frames/Sec

    OLED_Write_Byte(0xD9, OLED_CMD);//--set pre-charge period س
    OLED_Write_Byte(0xF1, OLED_CMD);//Set Pre-Charge as 15 Clocks & Discharge as 1 Clock

    OLED_Write_Byte(0x8D, OLED_CMD);//--set Charge Pump enable/disable ѹ
    OLED_Write_Byte(0x14, OLED_CMD);//--set(0x10) disable

    OLED_Write_Byte(0xA4, OLED_CMD);// Disable Entire Display On (0xa4/0xa5) ȫʾ
    OLED_Write_Byte(0xA6, OLED_CMD);// Disable Inverse Display On (0xa6/a7) ʾ

    OLED_Write_Byte(0xAF, OLED_CMD);// display ON ʾ
    OLED_Clear();
    OLED_Set_Pos(0, 0);
}

